#include "hmg.ch"

/***********************************************************
* Brow form definition
***********************************************************/
FUNCTION BrowFrmDefine()
LOCAL aGcol1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGcol2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGcol3 := {"TEXTBOX", "NUMERIC", "99,999,999", "99,999,999"}
LOCAL aGrdHead := {'Code', 'Description', 'Value'}
LOCAL aGrdCols := {aGcol1, aGcol2, aGcol3}
LOCAL aGrdJust := {GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_RIGHT}
LOCAL aGrdWidt := {100, 300, 150}

SET NAVIGATION EXTENDED
DEFINE WINDOW BrowFrm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Browser form" ;
 ICON "ICO_MAIN" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Brow_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME "Arial" FONTSIZE 10 ;
 NOTIFYTOOLTIP "NotifyToolTip" ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT "Arial" ;
  SIZE 10 ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION "e&Xit" ;
   ACTION btExitClick() ;
   SEPARATOR
  BUTTON btLoad ;
   CAPTION "&Load" ;
   ACTION btLoadClick() ;
   SEPARATOR
 END TOOLBAR

 DEFINE GRID datagrid1
  ROW 60
  COL 20
  WIDTH 800
  HEIGHT 400
  TOOLTIP "DoubleClick to select or add record"
  ONGOTFOCUS Nil
  ONLOSTFOCUS Nil
  ONSAVE Nil
  ONCHANGE Nil
  ONHEADCLICK Nil
  ONQUERYDATA Nil
  ONDBLCLICK Grd_DblClick()
  HEADERS aGrdHead
  WIDTHS aGrdWidt
  COLUMNCONTROLS aGrdCols
  JUSTIFY aGrdJust
 END GRID

END WINDOW

BrowFrm.Center

RETURN NIL

/***********************************************************
* Browser program main function
***********************************************************/
FUNCTION Brow_Main()
BrowFrm.Show
RETURN NIL

/***********************************************************
* Brow form IntClose event
***********************************************************/
STATIC FUNCTION Brow_OnIntClose()
BrowFrm.datagrid1.DeleteAllItems
RETURN NIL

/***********************************************************
* btExit pressed
***********************************************************/
STATIC FUNCTION btExitClick()
BrowFrm.datagrid1.DeleteAllItems
BrowFrm.Hide
RETURN NIL

/***********************************************************
* btLoad pressed
***********************************************************/
STATIC FUNCTION btLoadClick()
LOCAL cQuery := "", oQry := NIL, oRow := NIL
cQuery := "SELECT * FROM testtab "
cQuery += "ORDER BY progdescr ASC "

BrowFrm.datagrid1.DeleteAllItems
oQry := pboPgCon1:Query(cQuery)
IF oQry:NetErr()
 MSGSTOP( oQry:ErrorMsg() )
ELSE
 DO WHILE !oQry:Eof()
  oRow := oQry:Getrow()
  BrowFrm.datagrid1.AddItem( {oRow:Fieldget("progcodec"), oRow:Fieldget("progdescr"), oRow:Fieldget("prognumbr")} )
  oQry:Skip()
 ENDDO
ENDIF
oQry:Destroy()

RETURN NIL

/***********************************************************
* OnDblClick grid event
***********************************************************/
STATIC FUNCTION Grd_DblClick()

Edit_Main( BrowFrm.datagrid1.Value )

RETURN NIL
