#include "hmg.ch"

/***********************************************************
* Edit form definition
***********************************************************/
FUNCTION EditFrmDefine()

SET NAVIGATION EXTENDED
DEFINE WINDOW EditFrm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 660 ;
 HEIGHT 495 ;
 WINDOWTYPE STANDARD ;
 TITLE "Editer form" ;
 ICON "ICO_MAIN" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Edit_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME "Arial" FONTSIZE 10 ;
 NOTIFYTOOLTIP "NotifyToolTip" ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT "Arial" ;
  SIZE 10 ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION "e&Xit" ;
   ACTION btExitClick() ;
   SEPARATOR
  BUTTON btSave ;
   CAPTION "&Save" ;
   ACTION btSaveClick() ;
   SEPARATOR
  BUTTON btDelete ;
   CAPTION "&Delete" ;
   ACTION btDeleteClick() ;
   SEPARATOR
 END TOOLBAR

* N=its free, I=contain record data
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

 DEFINE TEXTBOX progcodec
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP "Enter valid code"
  MAXLENGTH 8
  CASECONVERT UPPER
 END TEXTBOX

 DEFINE TEXTBOX progdescr
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP "Enter valid description"
  MAXLENGTH 50
 END TEXTBOX

 DEFINE TEXTBOX prognumbr
  ROW 120
  COL 125
  HEIGHT 25
  DATATYPE NUMERIC
  INPUTMASK '99,999,999'
  TOOLTIP "Enter a valid quota"
 END TEXTBOX

END WINDOW

EditFrm.Center

RETURN NIL

/***********************************************************
* show Edit form
***********************************************************/
FUNCTION Edit_Main( nGridValue )

* I'm using this tecnique to lock form
IF EditFrm.FormStatus.Value <> "N"
 MSGSTOP("Form edit in use")
ELSE
 Edit_Show( nGridValue )
ENDIF
RETURN NIL

/***********************************************************
* show and fill Edit form
***********************************************************/
STATIC FUNCTION Edit_Show( nGridValue )
LOCAL aTemp := {}
PUBLIC pboEditQuery, pboEditRow, pbnEditRecStatus := -1, pbnEditGridValue := nGridValue

* I'm using this tecnique to lock form
EditFrm.FormStatus.Value := "I"

* fill out form fields
EditFrm.progcodec.Value := ""
EditFrm.progcodec.Enabled := .T.
EditFrm.progcodec.Setfocus
EditFrm.progdescr.Value := ""
EditFrm.prognumbr.Value := 0

EditFrm.Restore

IF pbnEditGridValue <> 0
 aTemp := GetProperty( "BrowFrm", "datagrid1", "item", pbnEditGridValue)
 EditFrm.progcodec.Value := aTemp[1]
ENDIF
Edit_LoadRecord()

RETURN NIL

/***********************************************************
* hide Edit form
***********************************************************/
STATIC FUNCTION Edit_OnIntClose()
Edit_StatusReset()
RETURN NIL

/***********************************************************
* btExit pressed
***********************************************************/
STATIC FUNCTION btExitClick()
Edit_StatusReset()
EditFrm.Hide
RETURN NIL

/***********************************************************
* btSave pressed
***********************************************************/
STATIC FUNCTION btSaveClick()
LOCAL lProceed := .T., aTemp := {}

* if record don't exist I must create a new row
IF pbnEditRecStatus == 0
 pboEditRow := pboEditQuery:Blank()
 IF pboEditQuery:NetErr()
  MSGSTOP( pboEditQuery:ErrorMsg() )
  lProceed := .F.
 ENDIF
ENDIF

IF lProceed == .T.
 pboEditRow:Fieldput( "adminproc", "editer.prg" )
 pboEditRow:Fieldput( "adminuser", pbcUserName )
 pboEditRow:Fieldput( "admintstp", HB_TTOS(HB_DATETIME()) )
 pboEditRow:Fieldput( "progcodec", EditFrm.progcodec.Value )
 pboEditRow:Fieldput( "progdescr", EditFrm.progdescr.Value )
 pboEditRow:Fieldput( "prognumbr", EditFrm.prognumbr.Value )
 IF pbnEditRecStatus == 0
  pboEditQuery:Append(pboEditRow)
 ELSE
  pboEditQuery:Update(pboEditRow)
 ENDIF
 IF pboEditQuery:NetErr()
  MSGSTOP( pboEditQuery:ErrorMsg() )
  lProceed := .F.
 ENDIF
ENDIF

IF lProceed == .T.
* this section only to update grid on BrowForm
 IF pbnEditGridValue == 0
  aTemp := {EditFrm.progcodec.Value, EditFrm.progdescr.Value, EditFrm.prognumbr.Value}
  DoMethod("BrowFrm", "datagrid1", "additem", aTemp)
  pbnEditGridValue := GetProperty("BrowFrm", "datagrid1", "ItemCount")
  SetProperty("BrowFrm", "datagrid1", "Value", pbnEditGridValue )
 ELSE
  aTemp := GetProperty( "BrowFrm", "datagrid1", "item", pbnEditGridValue)
  aTemp[1] := EditFrm.progcodec.Value
  aTemp[2] := EditFrm.progdescr.Value
  aTemp[3] := EditFrm.prognumbr.Value
  SetProperty( "BrowFrm", "datagrid1", "item", pbnEditGridValue, aTemp )
 ENDIF

 Edit_StatusReset()
 EditFrm.Hide
ENDIF

RETURN NIL

/***********************************************************
* btDelete pressed
***********************************************************/
STATIC FUNCTION btDeleteClick()

IF pbnEditRecStatus == 1
 pboEditQuery:Delete( pboEditRow )
 IF pboEditQuery:NetErr()
  MSGSTOP(  pboEditQuery:ErrorMsg() )
 ELSE
  DoMethod("BrowFrm", "datagrid1", "deleteitem", pbnEditGridValue)
  Edit_StatusReset()
  EditFrm.Hide
 ENDIF
ENDIF

RETURN NIL

/***********************************************************
* Edit_LoadRecord
***********************************************************/
STATIC FUNCTION Edit_LoadRecord()
LOCAL cQuery := ""

cQuery := "SELECT * FROM testtab "
cQuery += "WHERE progcodec='" + EditFrm.progcodec.Value + "'"
cQuery += "FOR UPDATE NOWAIT ;"

* 0=record don't exist, 1=record found and lock
pbnEditRecStatus := 0

* Start transaction
pboPgCon1:StartTransaction()
pboEditQuery := pboPgCon1:Query(cQuery)
IF pboEditQuery:NetErr()
 MSGSTOP( pboEditQuery:ErrorMsg() )
ELSE
 IF pboEditQuery:Lastrec() == 1
  pbnEditRecStatus := 1
  pboEditRow := pboEditQuery:Getrow()
  EditFrm.progcodec.Value := pboEditRow:Fieldget("progcodec")
  EditFrm.progcodec.Enabled := .F.
  EditFrm.progdescr.Value := pboEditRow:Fieldget("progdescr")
  EditFrm.progdescr.Setfocus
  EditFrm.prognumbr.Value := pboEditRow:Fieldget("prognumbr")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION Edit_StatusReset()
IF pbnEditRecStatus <> -1
 pboPgCon1:Commit()
 pboEditQuery:Destroy()
ENDIF
pbnEditRecStatus := -1

* I'm using this tecnique to lock form
EditFrm.FormStatus.Value := "N"
RETURN NIL

