#include "hmg.ch"

FUNCTION Main()

* PostGreSql connection
PUBLIC pboPgCon1 := NIL
PUBLIC pblConnect := .F.
PUBLIC pbcUserName := ""

SET( _SET_EPOCH, 2000 )
SET CENTURY ON
SET( _SET_DATEFORMAT, "dd-mm-yyyy" )

MainFrmDefine()
BrowFrmDefine()
EditFrmDefine()

ACTIVATE WINDOW ALL

* close and destroy connection
IF pblConnect == .T.
 pboPgCon1:Close()
 pboPgCon1:Destroy()
 pboPgCon1 := NIL
ENDIF

RETURN NIL

/***********************************************************
* main form definition
***********************************************************/
STATIC FUNCTION MainFrmDefine()

SET NAVIGATION EXTENDED
DEFINE WINDOW MainFrm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 980 ;
 HEIGHT 735 ;
 WINDOWTYPE MAIN ;
 TITLE "Main form" ;
 ICON "ICO_MAIN" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .T. ;
 SIZABLE .T. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT MainFrm_OnInit() ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Nil ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME "Arial" FONTSIZE 10 ;
 NOTIFYICON "ICO_MAIN" ;
 NOTIFYTOOLTIP "NotifyToolTip" ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE MAIN MENU
  DEFINE POPUP '&File'
   MENUITEM 'e&Xit' ACTION MainMnu_Exit()
  END POPUP
  DEFINE POPUP '&Create'
   MENUITEM '&Table' ACTION MainMnu_Create()
  END POPUP
  DEFINE POPUP '&Browse'
   MENUITEM '&Browse' ACTION MainMnu_Browse()
  END POPUP
 END MENU

END WINDOW

MainFrm.Center

RETURN NIL

/***********************************************************
* Main Form OnInit event
***********************************************************/
STATIC FUNCTION MainFrm_OnInit()
LOCAL cServer := "xxx.xxx.xxx.xxx", cUserName := "userlogin", cUserPwd := "userpassword", cDbName := "testdb", nPort := 5432
LOCAL cSet := "WIN1252"
LOCAL lDone := .T.
LOCAL cQuery := "", oQuery := NIL

pboPgCon1 := TPQServer():New( cServer , cDbName , cUsername , cUserPwd, nPort )
IF pboPgCon1:NetErr()
 MSGSTOP( pboPgCon1:ErrorMsg() )
 lDone := .F.
ENDIF

* setting up global var pblConnect
IF lDone
 MSGINFO( "Connected" )
 pblConnect := .T.
 pbcUserName := cUserName
ENDIF

* I'm using this method to tell what is client character set
IF lDone
 cQuery := "SET NAMES '"+ cSet + "';"
 oQuery := pboPgCon1:Query(cQuery)
 IF oQuery:NetErr()
  MSGSTOP(oQuery:ErrorMsg())
 ENDIF
 oQuery:Destroy()
ENDIF
RETURN NIL

/***********************************************************
* Main Form Menu Exit request
***********************************************************/
STATIC FUNCTION MainMnu_Exit()
ReleaseAllWindows()
RETURN NIL

/***********************************************************
* Main Form required action
***********************************************************/
STATIC FUNCTION MainMnu_Create()
IF !pblConnect
 MSGSTOP("Not connected")
 RETURN NIL
ENDIF
CreateTable()
RETURN NIL

/***********************************************************
* Main Form required action
***********************************************************/
STATIC FUNCTION MainMnu_Browse()
IF !pblConnect
 MSGSTOP("Not connected")
 RETURN NIL
ENDIF
Brow_Main()
RETURN NIL
